<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>bitten.upgrades</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="bitten-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="../index.html">Documentation Index</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="bitten-module.html">Package&nbsp;bitten</a> ::
        Module&nbsp;upgrades
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
      </table>
    </td>
  </tr>
</table>
<!-- ==================== MODULE DESCRIPTION ==================== -->
<h1 class="epydoc">Module upgrades</h1><p class="nomargin-top"></p>
<p>Automated upgrades for the Bitten database tables, and other data stored
in the Trac environment.</p>
<p><strong>Do not import and call directly!</strong></p>

<!-- ==================== FUNCTIONS ==================== -->
<a name="section-Functions"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Functions</span></td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="parse_scheme"></a><span class="summary-sig-name">parse_scheme</span>(<span class="summary-sig-arg">env</span>)</span><br />
      Retrieve the environment database scheme.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="update_sequence"></a><span class="summary-sig-name">update_sequence</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>,
        <span class="summary-sig-arg">tbl</span>,
        <span class="summary-sig-arg">col</span>)</span><br />
      Update a sequence associated with an autoincrement column.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="drop_index"></a><span class="summary-sig-name">drop_index</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>,
        <span class="summary-sig-arg">tbl</span>,
        <span class="summary-sig-arg">idx</span>)</span><br />
      Drop an index associated with a table.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_log_table"></a><span class="summary-sig-name">add_log_table</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add a table for storing the builds logs.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_recipe_to_config"></a><span class="summary-sig-name">add_recipe_to_config</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add a column for storing the build recipe to the build configuration
table.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_last_activity_to_build"></a><span class="summary-sig-name">add_last_activity_to_build</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add a column for storing the last activity to the build table.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_config_to_reports"></a><span class="summary-sig-name">add_config_to_reports</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add the name of the build configuration as metadata to report documents
stored in the BDB XML database.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_order_to_log"></a><span class="summary-sig-name">add_order_to_log</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add order column to log table to make sure that build logs are displayed
in the order they were generated.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_report_tables"></a><span class="summary-sig-name">add_report_tables</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add database tables for report storage.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="bitten.upgrades-module.html#xmldb_to_db" class="summary-sig-name">xmldb_to_db</a>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Migrate report data from Berkeley DB XML to SQL database.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="normalize_file_paths"></a><span class="summary-sig-name">normalize_file_paths</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Normalize the file separator in file names in reports.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="fixup_generators"></a><span class="summary-sig-name">fixup_generators</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Upgrade the identifiers for the recipe commands that generated log
messages and report data.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_error_table"></a><span class="summary-sig-name">add_error_table</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add the bitten_error table for recording step failure reasons.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="add_filename_to_logs"></a><span class="summary-sig-name">add_filename_to_logs</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Add filename column to log table to save where log files are stored.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="migrate_logs_to_files"></a><span class="summary-sig-name">migrate_logs_to_files</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Migrates logs that are stored in the bitten_log_messages table into files.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="fix_log_levels_misnaming"></a><span class="summary-sig-name">fix_log_levels_misnaming</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Renames or removes *.log.level files created by older versions of migrate_logs_to_files.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="remove_stray_log_levels_files"></a><span class="summary-sig-name">remove_stray_log_levels_files</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Remove *.log.levels files without a matching *.log file (old Bitten
versions did not delete .log.levels files when builds were deleted)</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="recreate_rule_with_int_id"></a><span class="summary-sig-name">recreate_rule_with_int_id</span>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Recreates the bitten_rule table with an integer id column rather than a text one.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="bitten.upgrades-module.html#add_config_platform_rev_index_to_build" class="summary-sig-name">add_config_platform_rev_index_to_build</a>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Adds a unique index on (config, platform, rev) to the bitten_build table.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="bitten.upgrades-module.html#fix_sequences" class="summary-sig-name">fix_sequences</a>(<span class="summary-sig-arg">env</span>,
        <span class="summary-sig-arg">db</span>)</span><br />
      Fixes any auto increment sequences that might have been left in an inconsistent state.</td>
          <td align="right" valign="top">
            
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== VARIABLES ==================== -->
<a name="section-Variables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Variables</span></td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="bitten.upgrades-module.html#map" class="summary-name">map</a> = <code title="{2: [add_log_table], 3: [add_recipe_to_config], 4: [add_config_to_repo\
rts], 5: [add_order_to_log, add_report_tables, xmldb_to_db], 6: [norma\
lize_file_paths, fixup_generators], 7: [add_error_table], 8: [add_file\
name_to_logs, migrate_logs_to_files], 9: [recreate_rule_with_int_id], \
10: [add_config_platform_rev_index_to_build, fix_sequences], 11: [fix_\
log_levels_misnaming, remove_stray_log_levels_files], 12: [add_last_ac\
tivity_to_build],}">{2: [add_log_table], 3: [add_recipe_to_config], 4: [add_<code class="variable-ellipsis">...</code></code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="__package__"></a><span class="summary-name">__package__</span> = <code title="'bitten'"><code class="variable-quote">'</code><code class="variable-string">bitten</code><code class="variable-quote">'</code></code>
    </td>
  </tr>
</table>
<!-- ==================== FUNCTION DETAILS ==================== -->
<a name="section-FunctionDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Function Details</span></td>
</tr>
</table>
<a name="xmldb_to_db"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">xmldb_to_db</span>(<span class="sig-arg">env</span>,
        <span class="sig-arg">db</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    >&nbsp;
    </td>
  </tr></table>
  
  <p>Migrate report data from Berkeley DB XML to SQL database.</p>
<p>Depending on the number of reports stored, this might take rather long.
After the upgrade is done, the bitten.dbxml file (and any BDB XML log files)
may be deleted. BDB XML is no longer used by Bitten.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="add_config_platform_rev_index_to_build"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">add_config_platform_rev_index_to_build</span>(<span class="sig-arg">env</span>,
        <span class="sig-arg">db</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    >&nbsp;
    </td>
  </tr></table>
  
  Adds a unique index on (config, platform, rev) to the bitten_build table.
Also drops the old index on bitten_build that serves no real purpose anymore.
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="fix_sequences"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">fix_sequences</span>(<span class="sig-arg">env</span>,
        <span class="sig-arg">db</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    >&nbsp;
    </td>
  </tr></table>
  
  <p>Fixes any auto increment sequences that might have been left in an inconsistent state.</p>
<p>Upgrade scripts for schema versions &gt; 10 should handle sequence updates correctly themselves.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== VARIABLES DETAILS ==================== -->
<a name="section-VariablesDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td align="left" colspan="2" class="table-header">
    <span class="table-header">Variables Details</span></td>
</tr>
</table>
<a name="map"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <h3 class="epydoc">map</h3>
  
  <dl class="fields">
  </dl>
  <dl class="fields">
    <dt>Value:</dt>
      <dd><table><tr><td><pre class="variable">
{2: [add_log_table], 3: [add_recipe_to_config], 4: [add_config_to_repo<span class="variable-linewrap"><img src="crarr.png" alt="\" /></span>
rts], 5: [add_order_to_log, add_report_tables, xmldb_to_db], 6: [norma<span class="variable-linewrap"><img src="crarr.png" alt="\" /></span>
lize_file_paths, fixup_generators], 7: [add_error_table], 8: [add_file<span class="variable-linewrap"><img src="crarr.png" alt="\" /></span>
name_to_logs, migrate_logs_to_files], 9: [recreate_rule_with_int_id], <span class="variable-linewrap"><img src="crarr.png" alt="\" /></span>
10: [add_config_platform_rev_index_to_build, fix_sequences], 11: [fix_<span class="variable-linewrap"><img src="crarr.png" alt="\" /></span>
log_levels_misnaming, remove_stray_log_levels_files], 12: [add_last_ac<span class="variable-linewrap"><img src="crarr.png" alt="\" /></span>
tivity_to_build],}
</pre></td></tr></table>
</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="bitten-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="../index.html">Documentation Index</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Fri Mar 11 14:53:35 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
